#include "WinMain.h"
#include "Board.h"
#include "Config.h"

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// O[oϐ
HINSTANCE	g_hInstance;

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// _CAÕbZ[W
BOOL CALLBACK DialogProc( HWND hWnd , UINT uMsg , WPARAM wParam , LPARAM lParam );

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// WindowsvÕGg[|Cg
int WINAPI WinMain( HINSTANCE hInstance , HINSTANCE hPrevInstance , LPSTR lpCmdLine , int nCmdShow )
{
	// CX^Xۑ
	g_hInstance = hInstance;

	///////////// EBhENXo^ /////////////
	WNDCLASSEX wcl;
	ZeroMemory( &wcl , sizeof( wcl ) );
	wcl.cbSize			= sizeof( wcl );									// \̂̃TCYiɂAPIō\̂̃o[W𔻒fj
	wcl.lpszClassName	= APP_NAME;											// NX
	wcl.hInstance		= hInstance;										// CX^X
	wcl.hIcon			= LoadIcon( hInstance , (LPCWSTR)IDI_ICON1 );		// EBhẼACR
	wcl.hCursor			= LoadCursor( hInstance , (LPCWSTR)IDC_CURSOR1 );	// EBhẼJ[\
	wcl.hbrBackground	= (HBRUSH)GetStockObject( WHITE_BRUSH );			// wiF
	wcl.lpfnWndProc		= WndProc;											// R[obN֐̃|C^
	wcl.lpszMenuName	= (LPCWSTR)IDR_MENU1;

	if( !RegisterClassEx( &wcl ) )
		return 0;

	/////////// EBhE쐬 ///////////
	HWND hWnd;
	hWnd = CreateWindow(APP_NAME , APP_NAME , WS_OVERLAPPEDWINDOW ,
						CW_USEDEFAULT , CW_USEDEFAULT ,		// ftHg̈ʒuɂ
						WIN_WIDTH , WIN_HEIGHT ,
						NULL , NULL , hInstance , 0 );

	ShowWindow( hWnd , nCmdShow );
	UpdateWindow( hWnd );

	/////////// bZ[W[v ///////////
	MSG msg;
	while( 0 != GetMessage( &msg , NULL , 0 , 0 ) )
	{
		TranslateMessage( &msg );
		DispatchMessage( &msg );
	}
	return msg.wParam;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// WindowsbZ[W󂯎R[obN֐
LRESULT CALLBACK WndProc( HWND hWnd , UINT uMsg , WPARAM wParam , LPARAM lParam )
{
	switch( uMsg )
	{
	case WM_COMMAND:
		// j[
		switch( LOWORD( wParam ) )
		{
		case ID_MENU_EXIT:		// uI(&X)v
			// AvP[VI
			PostQuitMessage( 0 );
			return 1;
		case ID_MENU_OPTION:	// uIvV(&O)v
			// ݒ\
			g_Config.ShowDialog( hWnd );
			return 1;
		}
		break;

	case WM_LBUTTONDOWN:
		// BoardNXɏۓ
		g_Board.OnLButtonDown( hWnd , LOWORD( lParam ) , HIWORD( lParam ) );
		return 1;

	case WM_RBUTTONDOWN:
		// BoardNXɏۓ
		g_Board.OnRButtonDown( hWnd , LOWORD( lParam ) , HIWORD( lParam ) );
		return 1;

	case WM_PAINT:
		// BoardNXɏۓ
		g_Board.OnPaint( hWnd );
		return 1;

	case WM_DESTROY:
		// AvP[VI
		PostQuitMessage( 0 );
		break;

	default:
		// ftHg̃bZ[W
		return DefWindowProc( hWnd , uMsg , wParam , lParam );
	}
	return 0;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
