#include "WinMain.h"
#include "Config.h"

////////////////////////////////////////////////////////////////////////////////////////////////////////////

CConfig g_Config;
CConfig* CConfig::m_pThis = NULL;

////////////////////////////////////////////////////////////////////////////////////////////////////////////

CConfig::CConfig()
{
	// this|C^ۑ
	m_pThis = this;

	// 
	Init();
	// [h
	if( !Load() )
		Init();
}
CConfig::~CConfig()
{
	// ۑ
	Save();

	// this|C^
	m_pThis = NULL;
}

// ݒ
bool CConfig::Init()
{
	ZeroMemory( m_szName , sizeof( m_szName ) );
	m_bCheckSound = true;
	return true;
}
// t@Cݒǂݍ
bool CConfig::Load()
{
	// t@Cnh
	HANDLE hFile;

	// t@CI[v
	hFile = CreateFile( TEXT( "save\\config.dat" ) ,
						GENERIC_READ ,
						FILE_SHARE_READ ,
						NULL ,
						OPEN_EXISTING ,
						0 ,
						NULL );

	// t@C݂邩
	if( hFile == INVALID_HANDLE_VALUE )
		return false;

	// ǂݎoCg
	DWORD dwReaded;

	// f[^ǂݎ
	if( !ReadFile( hFile , m_szName , sizeof( m_szName ) , &dwReaded , NULL ) )
	{
		::MessageBox( NULL , TEXT( "f[^̓ǂݎɎs܂" ) , TEXT( "G[" ) , MB_OK | MB_ICONSTOP );
		return false;
	}
	// f[^ǂݎ
	if( !ReadFile( hFile , &m_bCheckSound , sizeof( m_bCheckSound ) , &dwReaded , NULL ) )
	{
		::MessageBox( NULL , TEXT( "f[^̓ǂݎɎs܂" ) , TEXT( "G[" ) , MB_OK | MB_ICONSTOP );
		return false;
	}

	// nh
	CloseHandle( hFile );

	return true;
}
// t@CɊݒۑ
bool CConfig::Save()
{
	// fBNg쐬
	CreateDirectory( TEXT( "save" ) , NULL );

	// t@Cnh
	HANDLE hFile;

	// t@CI[v
	hFile = CreateFile( TEXT( "save\\config.dat" ) ,
						GENERIC_READ | GENERIC_WRITE ,
						0 ,
						NULL ,
						CREATE_ALWAYS ,
						0 ,
						NULL );

	// t@CI[vł
	if( hFile == INVALID_HANDLE_VALUE )
		return false;

	// 񂾃oCg
	DWORD dwWrited;

	// f[^
	if( !WriteFile( hFile , m_szName , sizeof( m_szName ) , &dwWrited , NULL ) )
	{
		::MessageBox( NULL , TEXT( "f[^݂̏Ɏs܂" ) , TEXT( "G[" ) , MB_OK | MB_ICONSTOP );
		return false;
	}
	if( !WriteFile( hFile , &m_bCheckSound , sizeof( m_bCheckSound ) , &dwWrited , NULL ) )
	{
		::MessageBox( NULL , TEXT( "f[^݂̏Ɏs܂" ) , TEXT( "G[" ) , MB_OK | MB_ICONSTOP );
		return false;
	}

	// nh
	CloseHandle( hFile );

	return true;
}

// ݒ_CAO\
bool CConfig::ShowDialog( HWND hWnd )
{
	::DialogBox( g_hInstance , (LPCWSTR)IDD_DIALOG1 , hWnd , (DLGPROC)CConfig::_DialogProc );
	return true;
}

// _CAOR[obN֐
BOOL CConfig::_DialogProc( HWND hWnd , UINT uMsg , WPARAM wParam , LPARAM lParam )
{
	if( m_pThis == NULL )
		return FALSE;
	return m_pThis->DialogProc( hWnd , uMsg , wParam , lParam );
}

// ̃[Jo[W
BOOL CConfig::DialogProc( HWND hWnd , UINT uMsg , WPARAM wParam , LPARAM lParam )
{
	switch( uMsg )
	{
	case WM_INITDIALOG:
		{
			// 
			HWND hEdit	= GetDlgItem( hWnd , IDC_EDIT1 );
			HWND hCheck	= GetDlgItem( hWnd , IDC_CHECK1 );

			SetWindowText( hEdit , m_szName );
			SendMessage( hCheck , BM_SETCHECK , (WPARAM)( m_bCheckSound ? BST_CHECKED : BST_UNCHECKED ) , 0 );
		}
		return TRUE;
		
	case WM_COMMAND:
		// j[
		switch( LOWORD( wParam ) )
		{
		case IDOK:
			{
				// OK{^ꂽ
				HWND hEdit	= GetDlgItem( hWnd , IDC_EDIT1 );
				HWND hCheck	= GetDlgItem( hWnd , IDC_CHECK1 );

				GetWindowText( hEdit , m_szName , sizeof( m_szName ) );
				m_bCheckSound = ( SendMessage( hCheck , BM_GETCHECK , 0 , 0 ) == BST_CHECKED );

				EndDialog( hWnd , 1 );
			}
			return TRUE;

		case IDCANCEL:
			{
				// LZ{^ꂽ
				EndDialog( hWnd , 0 );
			}
			return TRUE;
		}
		return TRUE;
	}

	return FALSE;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////
